package es.rediris.papi.jaas;

import java.io.IOException;
import javax.security.auth.callback.Callback;
import javax.security.auth.callback.CallbackHandler;
import javax.security.auth.callback.UnsupportedCallbackException;
import javax.servlet.http.Cookie;

public class CookieCallbackHandler implements CallbackHandler {

	private Cookie[] cookies;
	
	public CookieCallbackHandler() {
		super();
		this.cookies = null;
		// TODO Auto-generated constructor stub
	}
	
	public CookieCallbackHandler(Cookie[] cookies) {
		super();
		this.cookies = cookies;
	}
	
	public void handle(Callback[] callbacks) throws IOException,
			UnsupportedCallbackException {
		// TODO Crear instancia de PAPIPoA; aqui o en constructor?
		// OJO: Esta clase solo decodifica y parsea, no decide
		
		if ( (this.cookies == null) || (this.cookies.length == 0) )
			throw new IOException("No cookies available for authentication");
		
        for (int i=0; i < callbacks.length; i++)
        {
            if (callbacks[i] instanceof PAPIHcookCallback)
            {
            	PAPIHcookCallback phc = (PAPIHcookCallback)callbacks[i];
            	phc.setHcook(this.cookies[i]);
            }
            else if (callbacks[i] instanceof PAPILcookCallback)
            {
            	PAPILcookCallback plc = (PAPILcookCallback)callbacks[i];
            	plc.setUserData("He encontrado Lcook");
                //buscar Lcook, si la hay;
            	//decodificarla usando PAPIPoA
            	//parsear y fijar valores en el Callback
            }
            else
                throw new UnsupportedCallbackException(callbacks[i]);
        }

		
		
		
		
	}

	public Cookie[] getCookies() {
		return cookies;
	}

	public void setCookies(Cookie[] cookies) {
		this.cookies = cookies;
	}


}



